package com.plannaplan.controllers;

import com.plannaplan.security.CasValidationExcepiton;
import com.plannaplan.security.CasValidator;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@CrossOrigin
public class TokenController {

    public static String SERVICE_URL = "http://localhost:3000";

    @GetMapping("/token")
    public ResponseEntity<String> getToken(@RequestParam("ticket") final String ticket) {
        CasValidator validator = new CasValidator(SERVICE_URL,ticket);

        try{
            String authority = validator.validate();
            return new ResponseEntity<>(authority,HttpStatus.OK);
        }
        catch(CasValidationExcepiton e){
            return new ResponseEntity<>("Wrong ticket",HttpStatus.UNAUTHORIZED);
        }
        catch(Exception e){
            return new ResponseEntity<>(e.getMessage(),HttpStatus.INTERNAL_SERVER_ERROR);
        }

    }
}
